CREATE SEQUENCE id_getkey_seq;
CREATE TABLE "getkey" (
"id_getkey" int4 DEFAULT nextval('id_getkey_seq'),
"key" varchar(1)
);


CREATE OR REPLACE FUNCTION tetris() RETURNS varchar AS '
DECLARE

a integer;
b integer;
c integer;
x integer;
y integer;
test boolean;
rGetkey record;
timer float8;
timer_tmp float8;
timer_interval float8;
ecran varchar;			--(16*16)
ecran_tmp varchar(1)[];		--(16*16)
piece_db varchar(1)[];		--(4*4)
piece varchar(1)[16];	--(4*4)
piece_x integer;
piece_y integer;
ecran_jeu varchar(1)[300];	--(16*16)
matrice_jeu varchar(1)[180];	--(11*13)
score integer;
BEGIN
piece_db := ''{}'';
piece := ''{}'';
ecran_jeu := ''{}'';
ecran_tmp := ''{}'';
matrice_jeu := ''{}'';
test := false;
score := 0;

--on init les pieces
-- @
-- @
-- @
-- @
piece_db[1*1] := '' '';piece_db[1*2] := ''1'';piece_db[1*3] := '' '';piece_db[1*4] := '' '';
piece_db[1*5] := '' '';piece_db[1*6] := ''1'';piece_db[1*7] := '' '';piece_db[1*8] := '' '';
piece_db[1*9] := '' '';piece_db[1*10] := ''1'';piece_db[1*11] := '' '';piece_db[1*12] := '' '';
piece_db[1*13] := '' '';piece_db[1*14] := ''1'';piece_db[1*15] := '' '';piece_db[1*16] := '' '';

--
-- @@
-- @@
--
piece_db[17] := '' '';piece_db[18] := '' '';piece_db[19] := '' '';piece_db[20] := '' '';
piece_db[21] := '' '';piece_db[22] := ''2'';piece_db[23] := ''2'';piece_db[24] := '' '';
piece_db[25] := '' '';piece_db[26] := ''2'';piece_db[27] := ''2'';piece_db[28] := '' '';
piece_db[29] := '' '';piece_db[30] := '' '';piece_db[31] := '' '';piece_db[32] := '' '';

-- @
-- @@
--  @
-- 
piece_db[33] := '' '';piece_db[34] := ''3'';piece_db[35] := '' '';piece_db[36] := '' '';
piece_db[37] := '' '';piece_db[38] := ''3'';piece_db[39] := ''3'';piece_db[40] := '' '';
piece_db[41] := '' '';piece_db[42] := '' '';piece_db[43] := ''3'';piece_db[44] := '' '';
piece_db[45] := '' '';piece_db[46] := '' '';piece_db[47] := '' '';piece_db[48] := '' '';

--  @
-- @@
-- @
-- 
piece_db[49] := '' '';piece_db[50] := '' '';piece_db[51] := ''4'';piece_db[52] := '' '';
piece_db[53] := '' '';piece_db[54] := ''4'';piece_db[55] := ''4'';piece_db[56] := '' '';
piece_db[57] := '' '';piece_db[58] := ''4'';piece_db[59] := '' '';piece_db[60] := '' '';
piece_db[61] := '' '';piece_db[62] := '' '';piece_db[63] := '' '';piece_db[64] := '' '';


--  @
-- @@@
-- 
-- 
piece_db[65] := '' '';piece_db[66] := '' '';piece_db[67] := ''5'';piece_db[68] := '' '';
piece_db[69] := '' '';piece_db[70] := ''5'';piece_db[71] := ''5'';piece_db[72] := ''5'';
piece_db[73] := '' '';piece_db[74] := '' '';piece_db[75] := '' '';piece_db[76] := '' '';
piece_db[77] := '' '';piece_db[78] := '' '';piece_db[79] := '' '';piece_db[80] := '' '';


--   @
-- @@@
-- 
-- 
piece_db[81] := '' '';piece_db[82] := '' '';piece_db[83] := '' '';piece_db[84] := ''6'';
piece_db[85] := '' '';piece_db[86] := ''6'';piece_db[87] := ''6'';piece_db[88] := ''6'';
piece_db[89] := '' '';piece_db[90] := '' '';piece_db[91] := '' '';piece_db[92] := '' '';
piece_db[93] := '' '';piece_db[94] := '' '';piece_db[95] := '' '';piece_db[96] := '' '';


-- @
-- @@@
-- 
-- 
piece_db[97] := '' '';piece_db[98] := ''7'';piece_db[99] := '' '';piece_db[100] := '' '';
piece_db[101] := '' '';piece_db[102] := ''7'';piece_db[103] := ''7'';piece_db[104] := ''7'';
piece_db[105] := '' '';piece_db[106] := '' '';piece_db[107] := '' '';piece_db[108] := '' '';
piece_db[109] := '' '';piece_db[110] := '' '';piece_db[111] := '' '';piece_db[112] := '' '';

-- on init le jeu
-- 1 - @         @
-- 2 - @         @
-- 3 - @         @
-- 4 - @         @
-- 5 - @         @
-- 6 - @         @
-- 7 - @         @
-- 8 - @         @
-- 9 - @         @
--10 - @         @
--11 - @         @
--12 - @         @
--13 - @@@@@@@@@@@
--14 -
--15 - Level :
--16 - Score :
--   -1234567890123456

-- on remplis avec des " " (caracteres null)
x := 1;
WHILE x <= 300 LOOP
	ecran_jeu[x] := '' '';
	x := x + 1;
END LOOP;

x := 1;
WHILE x <= 180 LOOP
	matrice_jeu[x] := '' '';
	x := x + 1;
END LOOP;

-- on remplis les bords du jeu
x := 1;
y := 1;
WHILE y <= 13 LOOP
	matrice_jeu[x + 11 * y] := ''@'';
	y := y + 1;
END LOOP;
x := 11;
y := 1;
WHILE y <= 13 LOOP
	matrice_jeu[x + 11 * y] := ''@'';
	y := y + 1;
END LOOP;
x := 1;
y := 13;
WHILE x <= 11 LOOP
	matrice_jeu[x + 11 * y] := ''@'';
	x := x + 1;
END LOOP;

-- on met Level & Score
ecran_jeu[2 + 16 * 15] := ''L'';
ecran_jeu[3 + 16 * 15] := ''e'';
ecran_jeu[4 + 16 * 15] := ''v'';
ecran_jeu[5 + 16 * 15] := ''e'';
ecran_jeu[6 + 16 * 15] := ''l'';
ecran_jeu[7 + 16 * 15] := '' '';
ecran_jeu[8 + 16 * 15] := '':'';
ecran_jeu[2 + 16 * 16] := ''S'';
ecran_jeu[3 + 16 * 16] := ''c'';
ecran_jeu[4 + 16 * 16] := ''o'';
ecran_jeu[5 + 16 * 16] := ''r'';
ecran_jeu[6 + 16 * 16] := ''e'';
ecran_jeu[7 + 16 * 16] := '' '';
ecran_jeu[8 + 16 * 16] := '':'';

--***********************************
--on demarre le jeu
RAISE NOTICE ''Tetris v0.1a (24/01/2005)\nTouche :\n4 = gauche\n6 = droite\n5 = descendre\n8 = rotation\n7 = rotation inverse\n
2 = poser la piece\nq = quitter\n\nAppuyer sur n importe quel touche pour commencer (Lancer le .batch pour le support de jeu)\n\n\n\n(c) Froggy/FroggyCorp.'';

a := 0;

execute ''delete from getkey'';

WHILE a = 0 LOOP
	for rGetkey IN SELECT * FROM getkey LOOP	--bug ? ne me reload pas ma valeur via un select into a count(key) from getkey ?
		a := 1;
	END LOOP;
	select into a count(key) FROM getkey;
END LOOP;

--***********************************

--on init une nouvelle piece
piece_x := 3;
piece_y := -1;

select into piece select_piece(piece_db);

-- on init le timer
select into timer extract(epoch from timeofday()::timestamp);
timer_interval := 1;

-- on demarre le jeu
x := 0;
execute ''delete from getkey;'';

--on attache les differents array ensemble
select into ecran_tmp group_array(ecran_jeu, matrice_jeu, piece, piece_x, piece_y, score);
--on affiche l ecran
select into ecran print_array(ecran_tmp, 16, 16);
RAISE NOTICE ''%'', ecran;

WHILE x <> 1000000000 LOOP

	-- on traite le cas ou une touche est appuye
	for rGetkey IN select * FROM getkey ORDER BY id_getkey ASC LOOP
		test := true;	

		if rGetkey.key = ''4'' THEN		-- gauche
			piece_x := piece_x - 1;
			select into test piece_collision(matrice_jeu, piece, piece_x, piece_y);
			if test = true THEN
				piece_x := piece_x + 1;
			END IF;
		END IF;
		if rGetkey.key = ''6'' THEN		-- droite
			piece_x := piece_x + 1;
			select into test piece_collision(matrice_jeu, piece, piece_x, piece_y);
			if test = true THEN
				piece_x := piece_x - 1;
			END IF;
		END IF;
		if rGetkey.key = ''8'' THEN		-- rotation
			select into piece piece_rotate(piece);

			select into test piece_collision(matrice_jeu, piece, piece_x, piece_y);
			if test = true THEN
				select into piece piece_rotate(piece);
				select into piece piece_rotate(piece);
				select into piece piece_rotate(piece);
			END IF;
		END IF;
		if rGetkey.key = ''7'' THEN		-- rotation dans l autre sens
			select into piece piece_rotate(piece);
			select into piece piece_rotate(piece);
			select into piece piece_rotate(piece);

			select into test piece_collision(matrice_jeu, piece, piece_x, piece_y);
			if test = true THEN
				select into piece piece_rotate(piece);
			END IF;
		END IF;
		if rGetkey.key = ''5'' THEN		-- bas
			piece_y := piece_y + 1;
			select into test piece_collision(matrice_jeu, piece, piece_x, piece_y);
			if test = true THEN
				piece_y := piece_y - 1;
			END IF;
		END IF;
		if rGetkey.key = ''2'' THEN		-- tout en bas
			test := false;
			WHILE test = false LOOP
				piece_y := piece_y + 1;
				select into test piece_collision(matrice_jeu, piece, piece_x, piece_y);
			END LOOP;			
			if test = true THEN
				piece_y := piece_y - 1;
			END IF;
		END IF;


		-- un changement de position a ete accepte ?
		if test = false THEN
			--on attache les differents array ensemble
			select into ecran_tmp group_array(ecran_jeu, matrice_jeu, piece, piece_x, piece_y, score);

			--on affiche l ecran
			select into ecran print_array(ecran_tmp, 16, 16);
			RAISE NOTICE ''%'', ecran;
	
		END IF;

		--on efface l entree
		execute ''DELETE FROM getkey WHERE id_getkey = ''||rGetkey.id_getkey;
	END LOOP;


	select into timer_tmp extract(epoch from timeofday()::timestamp);
	if (timer_tmp - timer) > timer_interval THEN
		--on descend d un cran la piece
		piece_y := piece_y + 1;

		--on regarde si on est en collision
		select into test piece_collision(matrice_jeu, piece, piece_x, piece_y);
		if test = true THEN
			--on integre la piece au jeu
			piece_y := piece_y - 1;
			select into matrice_jeu group_piece(matrice_jeu, piece, piece_x, piece_y);

			--on regarde si on a une ligne de presente
			select into matrice_jeu detect_ligne(matrice_jeu);
			--on recup le nombre de ligne forme
			if ascii(matrice_jeu[1]) <> 0 THEN
				score := score + 50 * (2 ^ ascii(matrice_jeu[1]));
			END IF;

			matrice_jeu[1] := '' '';

			--on ajoute 1 point au score
			score := score + 1;

			--on init une nouvelle piece
			piece_x := 3;
			piece_y := -1;

			select into piece select_piece(piece_db);

			--on regarde si elle est en collision 
			select into test piece_collision(matrice_jeu, piece, piece_x, piece_y);
			if test = true THEN
				--perdu
				RETURN '' GAME OVER '';
			END IF;
		END IF;

		--on attache les differents array ensemble
		select into ecran_tmp group_array(ecran_jeu, matrice_jeu, piece, piece_x, piece_y, score);

		--on affiche l ecran
		select into ecran print_array(ecran_tmp, 16, 16);
		RAISE NOTICE ''%'', ecran;
		
		--on reinit le timer
		select into timer extract(epoch from timeofday()::timestamp);
	END IF;
	x := x + 1;
END LOOP;


RETURN ''End of game'';

END;
' LANGUAGE plpgsql;

-- ++++++++++++++++++++++++++++++++++++++++++++++

CREATE OR REPLACE FUNCTION group_array(varchar(1)[], varchar(1)[], varchar(1)[], integer, integer, integer) RETURNS varchar(1)[] AS '
DECLARE
x integer;
y integer;
a integer;
b float;
ecran_jeu ALIAS FOR $1;
matrice_jeu ALIAS FOR $2;
piece ALIAS FOR $3;
piece_x ALIAS FOR $4;
piece_y ALIAS FOR $5;
score ALIAS FOR $6;
ecran_final varchar(1)[];
score_tmp integer;
chiffre varchar(1);
BEGIN
ecran_final := ''{}'';

-- on link les trois arrays

--on remplit avec ecran_jeu
ecran_final := ecran_jeu;

--on remplit avec matrice_jeu
y := 1;
WHILE y <= 13 LOOP
	x := 1;
	WHILE x <= 11 LOOP
		ecran_final[x + y * 16] := matrice_jeu[x + y * 11];
		x := x + 1;
	END LOOP;
	y := y + 1;
END LOOP;

--on remplit avec piece
y := 1;
WHILE y <= 4 LOOP
	x := 1;
	WHILE x <= 4 LOOP
		if piece[x + (y - 1) * 4] <> '' '' THEN
			ecran_final[(x + piece_x) + (y + piece_y) * 16] := piece[x + (y - 1) * 4];
		END IF;
		x := x + 1;
	END LOOP;
	y := y + 1;
END LOOP;

-- on ecrit le score
-- 10,16
x := 10;
y := 16;

if score <> 0 THEN
	a := trunc(log(score));
	b := 10 ^ a;
	score_tmp := 0;

	while a >= 0 LOOP
		score_tmp := trunc(score / b) - trunc(score / b / 10) * 10;

		if score_tmp = 0 then
			ecran_final[x + y * 16] := ''0'';
		end if;
		if score_tmp = 1 then
			ecran_final[x + y * 16] := ''1'';
		end if;
		if score_tmp = 2 then
			ecran_final[x + y * 16] := ''2'';
		end if;
		if score_tmp = 3 then
			ecran_final[x + y * 16] := ''3'';
		end if;
		if score_tmp = 4 then
			ecran_final[x + y * 16] := ''4'';
		end if;
		if score_tmp = 5 then
			ecran_final[x + y * 16] := ''5'';
		end if;
		if score_tmp = 6 then
			ecran_final[x + y * 16] := ''6'';
		end if;
		if score_tmp = 7 then
			ecran_final[x + y * 16] := ''7'';
		end if;
		if score_tmp = 8 then
			ecran_final[x + y * 16] := ''8'';
		end if;
		if score_tmp = 9 then
			ecran_final[x + y * 16] := ''9'';
		end if;

		a := a - 1;
		b := 10 ^ a;
		x := x + 1;
	END LOOP;
ELSE
	ecran_final[x + y * 16] := ''0'';
END IF;

return ecran_final;

END;
' LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION group_piece(varchar(1)[], varchar(1)[], integer, integer) RETURNS varchar(1)[] AS '
DECLARE
x integer;
y integer;
matrice_jeu_tmp varchar(1)[];
matrice_jeu ALIAS FOR $1;
piece ALIAS FOR $2;
piece_x ALIAS FOR $3;
piece_y ALIAS FOR $4;
BEGIN

matrice_jeu_tmp := ''{}'';
matrice_jeu_tmp := matrice_jeu;

--on integre la piece a la matrice de jeu
y := 1;
WHILE y <= 4 LOOP
	x := 1;
	WHILE x <= 4 LOOP
		if piece[x + (y - 1) * 4] <> '' '' THEN
			matrice_jeu_tmp[(x + piece_x) + (y + piece_y) * 11] := piece[x + (y - 1) * 4];
		END IF;
		x := x + 1;
	END LOOP;
	y := y + 1;
END LOOP;



return matrice_jeu_tmp;

END;
' LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION piece_collision(varchar(1)[], varchar(1)[], integer, integer) RETURNS boolean AS '
DECLARE
x integer;
y integer;
test boolean;
matrice_jeu ALIAS FOR $1;
piece ALIAS FOR $2;
piece_x ALIAS FOR $3;
piece_y ALIAS FOR $4;
BEGIN
--x 2 -> 11
--y 1 -> 12
test := false;

--on regarde si la piece touche
y := 1;
WHILE y <= 4 LOOP
	x := 1;
	WHILE x <= 4 LOOP
		if x + piece_x >= 1 AND x + piece_x <= 11 THEN	--on gere le cas ou la piece depasse les limites de matrice_jeu
			if matrice_jeu[(x + piece_x) + (y + piece_y) * 11] <> '' '' AND piece[x + (y - 1) * 4] <> '' '' THEN
				test := true;
			END IF;
		END IF;
		x := x + 1;
	END LOOP;
	y := y + 1;
END LOOP;


return test;

END;
' LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION piece_rotate(varchar(1)[]) RETURNS varchar(1)[] AS '
DECLARE
a integer;
x integer;
y integer;
piece ALIAS FOR $1;
piece_tmp varchar(1)[];
BEGIN

piece_tmp := ''{}'';
a:= 1;
while a <= 16 loop
	piece_tmp[a] := '' '';
	a:= a +1;
end loop;

a := 1;
x := 4;
WHILE a <= 16 LOOP
	y := 1;
	WHILE y <= 4 LOOP
		piece_tmp[x + ((y - 1) * 4)] := piece[a];
		y := y + 1;
		a := a +1;
	END LOOP;
	x := x - 1;
END LOOP;

return piece_tmp;

END;
' LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION print_array(varchar[], integer, integer) RETURNS varchar AS '
DECLARE
x integer;
y integer;
array ALIAS FOR $1;
x_max ALIAS FOR $2;
y_max ALIAS FOR $3;
tmp varchar[];
char_tmp varchar(1);
array_tmp varchar;
BEGIN
tmp := array;
array_tmp = ''\n'';
y := 1;
WHILE y <= y_max LOOP
	x := 1;
	WHILE x <= x_max LOOP
		if tmp[x + y * x_max] IS NULL THEN
			tmp[x + y * x_max] := ''!'';
		END IF;
		array_tmp := array_tmp || tmp[x + y * x_max];
		x := x + 1;
	END LOOP;
	array_tmp := array_tmp || ''\n'';
	y := y + 1;
END LOOP;

return array_tmp;

END;
' LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION select_piece(varchar(1)[]) RETURNS varchar(1)[] AS '
DECLARE
a integer;
rand integer;
piece_db ALIAS FOR $1;
piece varchar(1)[16];
BEGIN

piece := ''{}'';

--on rand une piece entre 0 & 7
select into rand round(random() * 7);

a := 1;
WHILE a <= 16 LOOP
	piece[a] := piece_db[a + (rand - 1) * 16];
	a := a + 1;
END LOOP;

return piece;

END;
' LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION detect_ligne(varchar(1)[]) RETURNS varchar(1)[] AS '
DECLARE
x integer;
y integer;
y_tmp integer;
ligne integer;
compteur integer;
matrice_jeu ALIAS FOR $1;
matrice_jeu_tmp varchar(1)[];
BEGIN

ligne := 0;

-- on remplit la matrice_jeu_tmp
matrice_jeu_tmp := ''{}'';
x := 1;
WHILE x <= 180 LOOP
	matrice_jeu_tmp[x] := '' '';
	x := x + 1;
END LOOP;
x := 1;
y := 1;
WHILE y <= 13 LOOP
	matrice_jeu_tmp[x + 11 * y] := ''@'';
	y := y + 1;
END LOOP;
x := 11;
y := 1;
WHILE y <= 13 LOOP
	matrice_jeu_tmp[x + 11 * y] := ''@'';
	y := y + 1;
END LOOP;
x := 1;
y := 13;
WHILE x <= 11 LOOP
	matrice_jeu_tmp[x + 11 * y] := ''@'';
	x := x + 1;
END LOOP;

--x 2 -> 10
--y 1 -> 12

y := 12;
y_tmp := 12;
WHILE y >= 1 LOOP
	compteur := 0;
	x := 2;
	WHILE x <= 10 LOOP
		if matrice_jeu[x + y * 11] <> '' '' THEN
			compteur := compteur + 1;
		END IF;
		x := x + 1;
	END LOOP;

	if compteur <> 9 THEN
	--on a pas de ligne de former, on remplis matrice_jeu_tmp
		x := 2;
		WHILE x <= 10 LOOP
			matrice_jeu_tmp[x + y_tmp * 11] := matrice_jeu[x + y * 11];
			x := x + 1;
		END LOOP;
		y_tmp := y_tmp - 1;
	END IF;

	if compteur = 9 THEN
		ligne := ligne + 1;
	end if;

	y := y - 1;
END LOOP;

matrice_jeu_tmp[1] := chr(ligne);	--on exporte le nombre de ligne faite

return matrice_jeu_tmp;

END;
' LANGUAGE plpgsql;